#!/usr/bin/perl -w
######################################
# pwrap.pl v1.0.0 by Meleth in 2001. #
#                                    #
# A perlwrapper for UADE.            #
######################################

use strict;
use Term::Cap;
use vars qw/@mod $uade @player @ext $check $pid $sub @hold $zomb $repeat $subplay $random/;
use Cwd;
use POSIX ":sys_wait_h";

$uade="~/.xmms/uade";
$SIG{CHLD} = sub { REAPER(); };

$check = "0";
$sub = "0";
$zomb = "0";
$repeat = "0";
$random = "0";
$subplay = "0";

sub REAPER {
    my $stiff;
    while (($stiff = waitpid(-1, &WNOHANG)) > 0) {
	wait;
    }
    $SIG{CHLD} = \&REAPER;
    autoskip();
}


if (@ARGV == 0) {
    &opendefpl();
    &readformats();
    &menu();
}
elsif ($ARGV[0] eq "--help" or $ARGV[0] eq "-h" or $ARGV[0] eq "--h") {
    &usage();
}
elsif ($ARGV[0] eq "--pl"){
    print("Reading playlist.\n");
    if (-e $ARGV[1]){
	open(PLAYFILE, "$ARGV[1]") or die "Can't open playfile: $!\n";    
	foreach (<PLAYFILE>) {
	    my $file = openf($_);
	    chomp $file;
	    push @mod, $file;
	}
        close PLAYFILE;
	&readformats();
	&play();
	&menu();
    }else {
	&usage();
    }
}
else {
    foreach my $file (@ARGV){
	push @mod, openf($file);
    }
    &readformats();
    &play();
    &menu();    
}

sub readformats {
open(FORMATS, "$uade/deliplayers/uadeformats") or die "Can't find formats file: $!\n";
my $i=0;
foreach (<FORMATS>) {
    chomp;
    m/(.*?)\s(.*?$)/;
    $player[$i] = $2;
    $ext[$i] = $1;
    $i++;
    }
close FORMATS;
}


sub cls {
    my $terminal = Term::Cap->Tgetent( {OSPEED => 9600} );
    my $clear_string = $terminal->Tputs('cl');
    return $clear_string;
    }

sub drawmenu {
    my $current = parsef($mod[0]);
    #print (cls());
print "------------------------------------------------------\n";
    if ($check == 0){
	print "5 Play";
    }else {
	print "5 Stop";
    }
    print "                  / Open Playlist\n";
    print "4 Back                  + Display Playlist\n";
    print "6 Next                  * Remove current from playlist\n";
    print "7 Previous Subsong      - Clear playlist\n";
    print "9 Next Subsong          , Save Playlist\n";
    print "\n";
    if ($repeat == 0){
	print "1 Enqueue Directory     2 Repeat ON\n";
    }
    else {
	print "1 Enqueue Directory     2 Repeat OFF\n";
    }   
    if ($random == 0){
	print "3 Open Module           8 Random ON\n";
    }
    else {
	print "3 Open Module           8 Random OFF\n";
    }   
    print "\n\n0 Quit\n";
    print "------------------------------------------------------\n";
    print "Position : $current\n";
    print "Subsong  : $sub\n";
    if ($repeat == 0){
	print "Repeat   : OFF\n";
    }
    else {
	print "Repeat   : ON\n";
    }
    if ($random == 0){
	print "Random   : OFF\n";
    }
    else {
	print "Random   : ON\n";
    }
print "------------------------------------------------------\n";
}   



sub menu {
    my $msg="";
    $zomb = 0;
    my $i=0;
    while ($i==0) {
	drawmenu();
	print "$msg\n";
	my $com =getone();

      SWITCH: {
	  if ($com eq "5") {
          if ($check == 0) {$msg = (play()); last SWITCH;}
       	  else             {$msg = (stop(5)); last SWITCH;}}
	  if ($com eq "4") {$msg = (back()); last SWITCH;}
	  if ($com eq "6") {$msg = (nextmod()); last SWITCH;}
	  if ($com eq "7") {$msg = (psub()); last SWITCH;}
	  if ($com eq "*") {$msg = (remcur()); last SWITCH;}
	  if ($com eq "9") {$msg = (nsub()); last SWITCH;}
	  if ($com eq "3") {$msg = (lmod()); last SWITCH;}
	  if ($com eq "-") {$msg = (clist()); last SWITCH;}
	  if ($com eq "2") {$msg = (repeat($repeat)); last SWITCH;}
	  if ($com eq "8") {$msg = (random($random)); last SWITCH;}
	  if ($com eq "0") {quit(); last SWITCH;}
	  if ($com eq "1") {$msg = (opdir()); last SWITCH;}
	  if ($com eq "/") {$msg = (openfile()); last SWITCH;}
 	  if ($com eq "+") {$msg = (dispfile()); last SWITCH;}
 	  if ($com eq ",") {$msg = (savefile()); last SWITCH;}
	  else             {$msg = "Unknown Command"; last SWITCH;}
      }
    }
}

sub repeat {
    my $test = "@_";
    if ($test == 0){
	$repeat = 1;
	return "Repeat ON";
    }
    else {
	$repeat = 0;
	return "Repeat OFF";
    }
}

sub random {
    my $test = "@_";
    if ($test == 0){
	$random = 1;
	return "Random ON";
    }
    else {
	$random = 0;
	return "Random OFF";
    }
}

sub clist {
    if (defined $mod[0]) {
	for (my $i=1;$i <= $#mod;) {
	    pop @mod;
	}
    }
    if (defined $hold[0]){
	for (my $i=0;$i <= $#hold;) {
	    pop @hold;
	}
    }
    return "Playlist cleared";
}


sub lmod {
    print"Enter module: ";
    chomp(my $file = <STDIN>);
    if (-f $file){
	clist();
	if (defined $mod[0]) {
	    pop @mod;
	}
	my $t2 = openf($file);
	push @mod, "$t2";
	if ($check == 1) {
	    stop(1);
	}
	return "Loaded module: $t2";
    }
    else {
	return "Can't open module.";
    }
}


sub nsub {
    $sub++;
    $subplay = 1;
    stop(1);
    return "Skipping to next subsong";
}

sub psub {
    if ($sub != 0){
	$sub--;
	stop(1);
	return "Rewinding to previous subsong";
    }
    else {
	return "You are already playing the first subsong";
    }
}


sub savepl {
    my $savefile = "@_";
    if ((-e $savefile == 0 || -w $savefile) && -d $savefile == 0){
	open(SAVEFILE, ">$savefile") or die "Can't save playlist: $!\n";
	foreach my $entry (@hold) {
	    chomp $entry;
	    print SAVEFILE "$entry\n";
	}
	foreach my $entry (@mod) {
	    chomp $entry;
	    print SAVEFILE "$entry\n";
	}
	close SAVEFILE;
	return "Saved playlist as: $savefile";
    }
    else {
	return "Could not save playlist";
    }
}

sub dispfile {
    print (cls());
    my $i=0;
    foreach (@hold){
	print parsef($_),"\n";
	$i++;
	if ($i == 21) {
	    print"---Press any key to continue---\n";
	    getone();
	    $i=0
	    }
    }
    print "--->";
    foreach (@mod) {
	print parsef($_),"\n";
	$i++;
	if ($i == 21) {
	    print"---Press any key to continue---\n";
	    getone();
	    $i=0
	    }
    }
    print"---Press any key to continue---\n";
    getone();
    return "Displayed current playlist";
}

sub opdir {
    print"Enter directory: ";
    chomp(my $dir = <STDIN>);
    if (-d $dir){
	opendir(DIR, "$dir");
	my @files = readdir DIR;
	closedir DIR;
	foreach my $entry (@files){
	    my $temp = "$dir/$entry";
	    my $t2 = openf($temp);
	    if ($t2 ne "0") {
		push @mod, "$t2";
	    }
	}
	return "Enqueued directory: $dir";
    }
    else {
	return "Can't open directory.";
    }
}

sub openfile {
    print"Enter playlist to open: ";
    chomp(my $file = <STDIN>);
    if (-f $file){
	clist();
	if (defined $mod[0]) {
	    pop @mod;
	}
	open(PLAYFILE, "$file") or die "Can't open playlist: $!\n";
	foreach (<PLAYFILE>) {
	    chomp $_;
	    push @mod, "$_";
	}
	close PLAYFILE;
	return "Loaded playlist: $file";
    }
    else {
	return "Can't open playlist.";
    }
}

sub savefile {
    print"Enter name to save as: ";
    chomp(my $file = <STDIN>);
    my $hrm = savepl($file);
    return "$hrm";
}

sub opendefpl {
    if (-e "$ENV{HOME}/.wrap.pl"){
	open(PLAYFILE, "$ENV{HOME}/.wrap.pl") or die "Can't open playfile: $!\n";
	foreach (<PLAYFILE>) {
    	    chomp $_;
	    push @mod, $_;
	}
	close PLAYFILE;
    }
}

sub back {
    if (defined $hold[0]){
	$sub = 0;
	$zomb = 0;
	my $temp = pop @hold;
	unshift @mod, $temp;
	stop(1);
	return "Going back to the previous module.";
    }
    else {
	return "You are already on the first module";
    }
}

sub remcur {
    if (defined $mod[1]){
	my $shit = shift @mod;
	$shit = parsef($shit);
	$sub = 0;
	stop(1);
	return "Removed $shit from playlist";
    }
    else {
	return "You are not allowed to remove the last file";
    }
}

sub nextmod {
    if (defined $mod[1]){
	$sub = 0;
	$zomb = 0;
	my $temp = shift @mod;
	push @hold, $temp;
	stop(1);
	return "Skipping to the next module";
    }
    else {
	return "You are already on the last module";
    }
}

sub autoskip {
    if (defined $mod[1] && $subplay == 0){
	$sub = 0;
	if ($zomb == 6) {
	    exit;
	}
	if ($zomb == 0) {
	    if ($random == 1){
		my $roll = int (rand ($#mod+1));
		if ($roll !=  0){
		    $roll = --$roll;
		    my $temp = shift @mod;
		    push @hold, $temp;		    
		    my $c = splice(@mod,$roll,1);
		    unshift @mod ,$c;
		}
		else {
		    my $temp = shift @mod;
		    push @hold, $temp;
		}
	    }
	    else {
		my $temp = shift @mod;
		push @hold, $temp;
	    }
	}

	if ($zomb == 5) {
	    $zomb = 0;
	    return;
	}
	play();
	$zomb = 0;
	return "Autoskipping to the next module";
    }

    elsif (defined $subplay == 1){
	$subplay = 0;
	if ($zomb == 6) {
	    exit;
	}
	if ($zomb == 5) {
	    $zomb = 0;
	    return;
	}
	play();
	$zomb = 0;
	return "Autoskipping to the next module";
    }

    elsif ($repeat == 1) {
	$sub = 0;
	if ($zomb == 6) {
	    exit;
	}
	if ($zomb == 5) {
	    $zomb = 0;
	    return;
	}
	if (defined $hold[0]){
	    for (my $i=0;$i <= $#hold;) {
		my $temp = pop @hold;
		unshift @mod, $temp;
	    }
	}
	play();
	$zomb = 0;
    }
    else {
   	if ($zomb == 6) {
	    exit;
	}
	if ($zomb == 5) {
	    return;
	}
	$check = 0;       
	$zomb = 0;
	drawmenu();
	return "You are already on the last module";
    }
}

sub quit {
    print "QUIT\n";
    savepl("$ENV{HOME}/.wrap.pl");
    if ($check == 0) {
	exit;
    }
    if ($zomb == 5){
	exit;
    }
    stop(6);
}

sub stop {
    my $crap = "@_";
    if ($crap == 5){
	if ($check == 1){
	    $check = 0;
	    $zomb = 5;
	    kill 9,$pid;
	    kill 9,++$pid;
	    return "Stopping...";
	}
    }
    elsif ($crap == 6){
	$check = 0;
	$zomb = 6;
	if (defined $pid){
	    kill 9,$pid;
	    kill 9,++$pid;
    }
	else {
	    exit;
	}
    }
    else {
	if ($check == 1){
	    $zomb = 1;
	    if (defined $pid){
		kill 9,$pid;
		kill 9,++$pid;
	    }
	    if (!defined $pid){
		play();
	    }
	}
    }
}

sub play {
    if (defined $mod[0]) {
	my $file = parsef($mod[0]);
	$file =~ m/(.*?)\.(.*?$)/;
	my $form = lc $1;
	my $module = lc $2;
        my $c=0;
        my $replayer=0;
        foreach my $tst (@ext) {
	    if ($tst eq $form) {
		$replayer = $player[$c];
	    }
	    if ($tst eq $module) {
		$replayer = $player[$c];
	    }
	    $c++;
	}
    drawmenu();
    $zomb = 0;
    if (defined (++$pid)) {
	waitpid $pid,0;
    }
    if ($replayer eq "0") {
	shift @mod;
	play();
	return "Unknown format: $file. Removing it from the playlist.";
    }
    elsif ($replayer eq "custom"){
	$check = 1;
	$pid = (launch("$uade/uade -P \"$mod[0]\" -sub $sub 2> /dev/null"));
#	sleep 1;
	return "Playing....";
   }
   else {
	$check = 1;
	$pid = (launch("$uade/uade -P $uade/deliplayers/$replayer -M \"$mod[0]\" -sub $sub 2> /dev/null"));
#	sleep 1;
	return "Playing.....";
    }	       		       
  }
       
    else {
	return "Nothing to play.";
}

}
sub launch {
    my $prog = "@_";
    if ($pid = fork){
	return $pid;
    }
    elsif (defined $pid) {
	exec "$prog" or die "Can't start uade: $!\n";
	exit 0;
    }
    exit 0;
}

sub parsef {
    my $modu = "@_";
    $modu =~ s/.*\///;
    return "$modu";
}

sub openf {
    my $in = "@_";
    my $cdir = getcwd();
    $in =~ s/(.*\/)//;
    my $dir = $1;
    if ($in eq "." or $in eq ".."){
	return"0";
    }
    if (!defined $dir) {
	return "$cdir/$in";
    } 
    else {
	chdir $dir;
	$dir = getcwd();
	chdir $cdir;
	return "$dir/$in";
    }
}

sub usage {
    print "\nUSAGE: <program> [switch] (module1) (module2) etc.\n\n";
    print " --help            for this help\n";
    print " --pl playlist     to load a playlist on startup\n\n";
    print "---\n";
    print "All modules specified on the commandline ends up in a playfile.\n";
    print "Wildcards on the command line works too ie. *.mod etc.\n";
    print "You can't specify both modules and switches.\n\n";
    print "If the program is started without any arguments it will\n";
    print "try to open a default playlist in \$HOME/.wrap.pl.\n\n";
    print "This playlist is created by saving everything in your\n";
    print "playlist when you quit the program.\n\n";
    print "After this the menu will appear.\n";
    print "---\n\n";
    exit;
}


BEGIN {
use POSIX qw(:termios_h);
my ($term, $oterm, $echo, $noecho, $fd_stdin);
$fd_stdin = fileno(STDIN);
$term = POSIX::Termios->new();
$term->getattr($fd_stdin);
$oterm = $term->getlflag();
$echo = ECHO|ECHOK|ICANON;
$noecho = $oterm & ~$echo;
sub cbreak {
    $term->setlflag($noecho);
    $term->setcc(VTIME, 1);
    $term->setattr($fd_stdin, TCSANOW);
}
sub cooked {
    $term->setlflag($oterm);
    $term->setcc(VTIME,0);
    $term->setattr($fd_stdin, TCSANOW);
}
sub getone {
    my $key = "";
    cbreak();
    sysread(STDIN, $key, 1);
    cooked();
    return $key;
}
}
END { cooked() }



